/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-07-17 09:24:41.
 * *************************************************
 */

package cn.com.qmth.examcloud.app;

import com.google.common.collect.Lists;
import io.swagger.annotations.ApiOperation;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.ParameterBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.schema.ModelRef;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Parameter;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

import java.util.List;

@Configuration
@EnableSwagger2
public class SwaggerConfig {

    @Bean
    public Docket buildDocket() {
        //定义要生成API文档的基础包
        String basePackage = "cn.com.qmth.examcloud.app.controller";
        //全局参数
        List<Parameter> parameters = Lists.newArrayList();
        ParameterBuilder key = new ParameterBuilder();
        key.name("key").modelRef(new ModelRef("String")).parameterType("header").build();
        parameters.add(key.build());
        ParameterBuilder token = new ParameterBuilder();
        token.name("token").modelRef(new ModelRef("String")).parameterType("header").build();
        parameters.add(token.build());
        return new Docket(DocumentationType.SWAGGER_2)
                .groupName("Version 1.0")
                .apiInfo(buildApiInfo())
                .useDefaultResponseMessages(false)
                .select()
                //.apis(RequestHandlerSelectors.basePackage(basePackage))
                .apis(RequestHandlerSelectors.withMethodAnnotation(ApiOperation.class))
                .paths(PathSelectors.any())
                .build().globalOperationParameters(parameters);
    }

    public ApiInfo buildApiInfo() {
        return new ApiInfoBuilder()
                .title("考生端APP接口文档")
                .version("1.0")
                .build();
    }

}